// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `DHCP.ice'

#ifndef ___usr_src_RPM_BUILD_Tartarus_0_8_3__waf_build_default_slice_DHCP_DHCP_h__
#define ___usr_src_RPM_BUILD_Tartarus_0_8_3__waf_build_default_slice_DHCP_DHCP_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <core/exceptions.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace Tartarus
{

namespace iface
{

namespace DHCP
{

class Scope;

class Host;

class Range;

class Subnet;

class Server;

class Daemon;

}

}

}

}

namespace Tartarus
{

namespace iface
{

namespace DHCP
{

class Scope;
bool operator==(const Scope&, const Scope&);
bool operator<(const Scope&, const Scope&);

class Host;
bool operator==(const Host&, const Host&);
bool operator<(const Host&, const Host&);

class Range;
bool operator==(const Range&, const Range&);
bool operator<(const Range&, const Range&);

class Subnet;
bool operator==(const Subnet&, const Subnet&);
bool operator<(const Subnet&, const Subnet&);

class Server;
bool operator==(const Server&, const Server&);
bool operator<(const Server&, const Server&);

class Daemon;
bool operator==(const Daemon&, const Daemon&);
bool operator<(const Daemon&, const Daemon&);

}

}

}

namespace IceInternal
{

::Ice::Object* upCast(::Tartarus::iface::DHCP::Scope*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::DHCP::Scope*);

::Ice::Object* upCast(::Tartarus::iface::DHCP::Host*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::DHCP::Host*);

::Ice::Object* upCast(::Tartarus::iface::DHCP::Range*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::DHCP::Range*);

::Ice::Object* upCast(::Tartarus::iface::DHCP::Subnet*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::DHCP::Subnet*);

::Ice::Object* upCast(::Tartarus::iface::DHCP::Server*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::DHCP::Server*);

::Ice::Object* upCast(::Tartarus::iface::DHCP::Daemon*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::DHCP::Daemon*);

}

namespace Tartarus
{

namespace iface
{

namespace DHCP
{

typedef ::IceInternal::Handle< ::Tartarus::iface::DHCP::Scope> ScopePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::DHCP::Scope> ScopePrx;

void __read(::IceInternal::BasicStream*, ScopePrx&);
void __patch__ScopePtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::Tartarus::iface::DHCP::Host> HostPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::DHCP::Host> HostPrx;

void __read(::IceInternal::BasicStream*, HostPrx&);
void __patch__HostPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::Tartarus::iface::DHCP::Range> RangePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::DHCP::Range> RangePrx;

void __read(::IceInternal::BasicStream*, RangePrx&);
void __patch__RangePtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::Tartarus::iface::DHCP::Subnet> SubnetPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::DHCP::Subnet> SubnetPrx;

void __read(::IceInternal::BasicStream*, SubnetPrx&);
void __patch__SubnetPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::Tartarus::iface::DHCP::Server> ServerPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::DHCP::Server> ServerPrx;

void __read(::IceInternal::BasicStream*, ServerPrx&);
void __patch__ServerPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::Tartarus::iface::DHCP::Daemon> DaemonPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::DHCP::Daemon> DaemonPrx;

void __read(::IceInternal::BasicStream*, DaemonPrx&);
void __patch__DaemonPtr(void*, ::Ice::ObjectPtr&);

}

}

}

namespace Tartarus
{

namespace iface
{

namespace DHCP
{

typedef ::std::vector< ::std::string> StrSeq;

enum HostIdType
{
    IDENTITY,
    HARDWARE
};

void __write(::IceInternal::BasicStream*, HostIdType);
void __read(::IceInternal::BasicStream*, HostIdType&);

struct HostId
{
    ::Tartarus::iface::DHCP::HostIdType type;
    ::std::string value;

    bool operator==(const HostId&) const;
    bool operator<(const HostId&) const;
    bool operator!=(const HostId& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const HostId& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const HostId& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const HostId& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::map< ::std::string, ::std::string> StrStrMap;
void __writeStrStrMap(::IceInternal::BasicStream*, const StrStrMap&);
void __readStrStrMap(::IceInternal::BasicStream*, StrStrMap&);

typedef ::std::vector< ::Tartarus::iface::DHCP::HostPrx> HostSeq;
void __writeHostSeq(::IceInternal::BasicStream*, const ::Tartarus::iface::DHCP::HostPrx*, const ::Tartarus::iface::DHCP::HostPrx*);
void __readHostSeq(::IceInternal::BasicStream*, HostSeq&);

const ::Ice::Int KNOWN = 1;

const ::Ice::Int UNKNOWN = 2;

struct IpRange
{
    ::std::string start;
    ::std::string end;
    bool hasValue;

    bool operator==(const IpRange&) const;
    bool operator<(const IpRange&) const;
    bool operator!=(const IpRange& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const IpRange& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const IpRange& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const IpRange& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::Tartarus::iface::DHCP::RangePrx> RangeSeq;
void __writeRangeSeq(::IceInternal::BasicStream*, const ::Tartarus::iface::DHCP::RangePrx*, const ::Tartarus::iface::DHCP::RangePrx*);
void __readRangeSeq(::IceInternal::BasicStream*, RangeSeq&);

typedef ::std::vector< ::Tartarus::iface::DHCP::SubnetPrx> SubnetSeq;
void __writeSubnetSeq(::IceInternal::BasicStream*, const ::Tartarus::iface::DHCP::SubnetPrx*, const ::Tartarus::iface::DHCP::SubnetPrx*);
void __readSubnetSeq(::IceInternal::BasicStream*, SubnetSeq&);

class KeyError : public ::Tartarus::iface::core::Error
{
public:

    KeyError() {}
    KeyError(const ::std::string&, const ::std::string&);
    virtual ~KeyError() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::std::string key;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static KeyError __KeyError_init;

class ValueError : public ::Tartarus::iface::core::Error
{
public:

    ValueError() {}
    ValueError(const ::std::string&, const ::std::string&, const ::std::string&);
    virtual ~ValueError() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::std::string key;
    ::std::string value;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class AlreadyExistsError : public ::Tartarus::iface::core::Error
{
public:

    AlreadyExistsError() {}
    explicit AlreadyExistsError(const ::std::string&);
    virtual ~AlreadyExistsError() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

}

}

}

namespace IceProxy
{

namespace Tartarus
{

namespace iface
{

namespace DHCP
{

class Scope : virtual public ::IceProxy::Ice::Object
{
public:

    ::Tartarus::iface::DHCP::StrStrMap options()
    {
        return options(0);
    }
    ::Tartarus::iface::DHCP::StrStrMap options(const ::Ice::Context& __ctx)
    {
        return options(&__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::StrStrMap options(const ::Ice::Context*);
    
public:

    void setOption(const ::std::string& key, const ::std::string& value)
    {
        setOption(key, value, 0);
    }
    void setOption(const ::std::string& key, const ::std::string& value, const ::Ice::Context& __ctx)
    {
        setOption(key, value, &__ctx);
    }
    
private:

    void setOption(const ::std::string&, const ::std::string&, const ::Ice::Context*);
    
public:

    void unsetOption(const ::std::string& key)
    {
        unsetOption(key, 0);
    }
    void unsetOption(const ::std::string& key, const ::Ice::Context& __ctx)
    {
        unsetOption(key, &__ctx);
    }
    
private:

    void unsetOption(const ::std::string&, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<Scope> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Scope> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Scope*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Scope*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class Host : virtual public ::IceProxy::Tartarus::iface::DHCP::Scope
{
public:

    ::std::string name()
    {
        return name(0);
    }
    ::std::string name(const ::Ice::Context& __ctx)
    {
        return name(&__ctx);
    }
    
private:

    ::std::string name(const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DHCP::HostId id()
    {
        return id(0);
    }
    ::Tartarus::iface::DHCP::HostId id(const ::Ice::Context& __ctx)
    {
        return id(&__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::HostId id(const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<Host> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Host> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Host*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Host*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class Range : virtual public ::IceProxy::Tartarus::iface::DHCP::Scope
{
public:

    ::std::string id()
    {
        return id(0);
    }
    ::std::string id(const ::Ice::Context& __ctx)
    {
        return id(&__ctx);
    }
    
private:

    ::std::string id(const ::Ice::Context*);
    
public:

    ::Ice::Int caps()
    {
        return caps(0);
    }
    ::Ice::Int caps(const ::Ice::Context& __ctx)
    {
        return caps(&__ctx);
    }
    
private:

    ::Ice::Int caps(const ::Ice::Context*);
    
public:

    void setCaps(::Ice::Int caps)
    {
        setCaps(caps, 0);
    }
    void setCaps(::Ice::Int caps, const ::Ice::Context& __ctx)
    {
        setCaps(caps, &__ctx);
    }
    
private:

    void setCaps(::Ice::Int, const ::Ice::Context*);
    
public:

    void addrs(::std::string& start, ::std::string& end)
    {
        addrs(start, end, 0);
    }
    void addrs(::std::string& start, ::std::string& end, const ::Ice::Context& __ctx)
    {
        addrs(start, end, &__ctx);
    }
    
private:

    void addrs(::std::string&, ::std::string&, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<Range> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Range> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Range*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Range*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class Subnet : virtual public ::IceProxy::Tartarus::iface::DHCP::Scope
{
public:

    ::std::string id()
    {
        return id(0);
    }
    ::std::string id(const ::Ice::Context& __ctx)
    {
        return id(&__ctx);
    }
    
private:

    ::std::string id(const ::Ice::Context*);
    
public:

    ::std::string cidr()
    {
        return cidr(0);
    }
    ::std::string cidr(const ::Ice::Context& __ctx)
    {
        return cidr(&__ctx);
    }
    
private:

    ::std::string cidr(const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DHCP::RangeSeq ranges()
    {
        return ranges(0);
    }
    ::Tartarus::iface::DHCP::RangeSeq ranges(const ::Ice::Context& __ctx)
    {
        return ranges(&__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::RangeSeq ranges(const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DHCP::RangePrx getRange(const ::std::string& id)
    {
        return getRange(id, 0);
    }
    ::Tartarus::iface::DHCP::RangePrx getRange(const ::std::string& id, const ::Ice::Context& __ctx)
    {
        return getRange(id, &__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::RangePrx getRange(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string& addr)
    {
        return findRange(addr, 0);
    }
    ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string& addr, const ::Ice::Context& __ctx)
    {
        return findRange(addr, &__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DHCP::RangePrx addRange(const ::std::string& start, const ::std::string& end, ::Ice::Int caps)
    {
        return addRange(start, end, caps, 0);
    }
    ::Tartarus::iface::DHCP::RangePrx addRange(const ::std::string& start, const ::std::string& end, ::Ice::Int caps, const ::Ice::Context& __ctx)
    {
        return addRange(start, end, caps, &__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::RangePrx addRange(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Context*);
    
public:

    void delRange(const ::std::string& ip)
    {
        delRange(ip, 0);
    }
    void delRange(const ::std::string& ip, const ::Ice::Context& __ctx)
    {
        delRange(ip, &__ctx);
    }
    
private:

    void delRange(const ::std::string&, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<Subnet> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Subnet> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Subnet*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Subnet*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class Server : virtual public ::IceProxy::Tartarus::iface::DHCP::Scope
{
public:

    ::Tartarus::iface::DHCP::SubnetSeq subnets()
    {
        return subnets(0);
    }
    ::Tartarus::iface::DHCP::SubnetSeq subnets(const ::Ice::Context& __ctx)
    {
        return subnets(&__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::SubnetSeq subnets(const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DHCP::SubnetPrx findSubnet(const ::std::string& decl)
    {
        return findSubnet(decl, 0);
    }
    ::Tartarus::iface::DHCP::SubnetPrx findSubnet(const ::std::string& decl, const ::Ice::Context& __ctx)
    {
        return findSubnet(decl, &__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::SubnetPrx findSubnet(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DHCP::SubnetPrx addSubnet(const ::std::string& decl)
    {
        return addSubnet(decl, 0);
    }
    ::Tartarus::iface::DHCP::SubnetPrx addSubnet(const ::std::string& decl, const ::Ice::Context& __ctx)
    {
        return addSubnet(decl, &__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::SubnetPrx addSubnet(const ::std::string&, const ::Ice::Context*);
    
public:

    void delSubnet(const ::std::string& id)
    {
        delSubnet(id, 0);
    }
    void delSubnet(const ::std::string& id, const ::Ice::Context& __ctx)
    {
        delSubnet(id, &__ctx);
    }
    
private:

    void delSubnet(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DHCP::HostSeq hosts()
    {
        return hosts(0);
    }
    ::Tartarus::iface::DHCP::HostSeq hosts(const ::Ice::Context& __ctx)
    {
        return hosts(&__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::HostSeq hosts(const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DHCP::HostPrx getHost(const ::std::string& name)
    {
        return getHost(name, 0);
    }
    ::Tartarus::iface::DHCP::HostPrx getHost(const ::std::string& name, const ::Ice::Context& __ctx)
    {
        return getHost(name, &__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::HostPrx getHost(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DHCP::HostPrx addHost(const ::std::string& name, const ::Tartarus::iface::DHCP::HostId& id)
    {
        return addHost(name, id, 0);
    }
    ::Tartarus::iface::DHCP::HostPrx addHost(const ::std::string& name, const ::Tartarus::iface::DHCP::HostId& id, const ::Ice::Context& __ctx)
    {
        return addHost(name, id, &__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::HostPrx addHost(const ::std::string&, const ::Tartarus::iface::DHCP::HostId&, const ::Ice::Context*);
    
public:

    void delHost(const ::std::string& name)
    {
        delHost(name, 0);
    }
    void delHost(const ::std::string& name, const ::Ice::Context& __ctx)
    {
        delHost(name, &__ctx);
    }
    
private:

    void delHost(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string& addr)
    {
        return findRange(addr, 0);
    }
    ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string& addr, const ::Ice::Context& __ctx)
    {
        return findRange(addr, &__ctx);
    }
    
private:

    ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string&, const ::Ice::Context*);
    
public:

    bool isConfigured()
    {
        return isConfigured(0);
    }
    bool isConfigured(const ::Ice::Context& __ctx)
    {
        return isConfigured(&__ctx);
    }
    
private:

    bool isConfigured(const ::Ice::Context*);
    
public:

    void reset()
    {
        reset(0);
    }
    void reset(const ::Ice::Context& __ctx)
    {
        reset(&__ctx);
    }
    
private:

    void reset(const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<Server> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class Daemon : virtual public ::IceProxy::Ice::Object
{
public:

    void start()
    {
        start(0);
    }
    void start(const ::Ice::Context& __ctx)
    {
        start(&__ctx);
    }
    
private:

    void start(const ::Ice::Context*);
    
public:

    void stop()
    {
        stop(0);
    }
    void stop(const ::Ice::Context& __ctx)
    {
        stop(&__ctx);
    }
    
private:

    void stop(const ::Ice::Context*);
    
public:

    bool running()
    {
        return running(0);
    }
    bool running(const ::Ice::Context& __ctx)
    {
        return running(&__ctx);
    }
    
private:

    bool running(const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<Daemon> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Daemon> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Daemon*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Daemon*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

}

}

}

}

namespace IceDelegate
{

namespace Tartarus
{

namespace iface
{

namespace DHCP
{

class Scope : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::Tartarus::iface::DHCP::StrStrMap options(const ::Ice::Context*) = 0;

    virtual void setOption(const ::std::string&, const ::std::string&, const ::Ice::Context*) = 0;

    virtual void unsetOption(const ::std::string&, const ::Ice::Context*) = 0;
};

class Host : virtual public ::IceDelegate::Tartarus::iface::DHCP::Scope
{
public:

    virtual ::std::string name(const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DHCP::HostId id(const ::Ice::Context*) = 0;
};

class Range : virtual public ::IceDelegate::Tartarus::iface::DHCP::Scope
{
public:

    virtual ::std::string id(const ::Ice::Context*) = 0;

    virtual ::Ice::Int caps(const ::Ice::Context*) = 0;

    virtual void setCaps(::Ice::Int, const ::Ice::Context*) = 0;

    virtual void addrs(::std::string&, ::std::string&, const ::Ice::Context*) = 0;
};

class Subnet : virtual public ::IceDelegate::Tartarus::iface::DHCP::Scope
{
public:

    virtual ::std::string id(const ::Ice::Context*) = 0;

    virtual ::std::string cidr(const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DHCP::RangeSeq ranges(const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DHCP::RangePrx getRange(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DHCP::RangePrx addRange(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Context*) = 0;

    virtual void delRange(const ::std::string&, const ::Ice::Context*) = 0;
};

class Server : virtual public ::IceDelegate::Tartarus::iface::DHCP::Scope
{
public:

    virtual ::Tartarus::iface::DHCP::SubnetSeq subnets(const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DHCP::SubnetPrx findSubnet(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DHCP::SubnetPrx addSubnet(const ::std::string&, const ::Ice::Context*) = 0;

    virtual void delSubnet(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DHCP::HostSeq hosts(const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DHCP::HostPrx getHost(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DHCP::HostPrx addHost(const ::std::string&, const ::Tartarus::iface::DHCP::HostId&, const ::Ice::Context*) = 0;

    virtual void delHost(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string&, const ::Ice::Context*) = 0;

    virtual bool isConfigured(const ::Ice::Context*) = 0;

    virtual void reset(const ::Ice::Context*) = 0;
};

class Daemon : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void start(const ::Ice::Context*) = 0;

    virtual void stop(const ::Ice::Context*) = 0;

    virtual bool running(const ::Ice::Context*) = 0;
};

}

}

}

}

namespace IceDelegateM
{

namespace Tartarus
{

namespace iface
{

namespace DHCP
{

class Scope : virtual public ::IceDelegate::Tartarus::iface::DHCP::Scope,
              virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::Tartarus::iface::DHCP::StrStrMap options(const ::Ice::Context*);

    virtual void setOption(const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual void unsetOption(const ::std::string&, const ::Ice::Context*);
};

class Host : virtual public ::IceDelegate::Tartarus::iface::DHCP::Host,
             virtual public ::IceDelegateM::Tartarus::iface::DHCP::Scope
{
public:

    virtual ::std::string name(const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::HostId id(const ::Ice::Context*);
};

class Range : virtual public ::IceDelegate::Tartarus::iface::DHCP::Range,
              virtual public ::IceDelegateM::Tartarus::iface::DHCP::Scope
{
public:

    virtual ::std::string id(const ::Ice::Context*);

    virtual ::Ice::Int caps(const ::Ice::Context*);

    virtual void setCaps(::Ice::Int, const ::Ice::Context*);

    virtual void addrs(::std::string&, ::std::string&, const ::Ice::Context*);
};

class Subnet : virtual public ::IceDelegate::Tartarus::iface::DHCP::Subnet,
               virtual public ::IceDelegateM::Tartarus::iface::DHCP::Scope
{
public:

    virtual ::std::string id(const ::Ice::Context*);

    virtual ::std::string cidr(const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::RangeSeq ranges(const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::RangePrx getRange(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::RangePrx addRange(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Context*);

    virtual void delRange(const ::std::string&, const ::Ice::Context*);
};

class Server : virtual public ::IceDelegate::Tartarus::iface::DHCP::Server,
               virtual public ::IceDelegateM::Tartarus::iface::DHCP::Scope
{
public:

    virtual ::Tartarus::iface::DHCP::SubnetSeq subnets(const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::SubnetPrx findSubnet(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::SubnetPrx addSubnet(const ::std::string&, const ::Ice::Context*);

    virtual void delSubnet(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::HostSeq hosts(const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::HostPrx getHost(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::HostPrx addHost(const ::std::string&, const ::Tartarus::iface::DHCP::HostId&, const ::Ice::Context*);

    virtual void delHost(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string&, const ::Ice::Context*);

    virtual bool isConfigured(const ::Ice::Context*);

    virtual void reset(const ::Ice::Context*);
};

class Daemon : virtual public ::IceDelegate::Tartarus::iface::DHCP::Daemon,
               virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void start(const ::Ice::Context*);

    virtual void stop(const ::Ice::Context*);

    virtual bool running(const ::Ice::Context*);
};

}

}

}

}

namespace IceDelegateD
{

namespace Tartarus
{

namespace iface
{

namespace DHCP
{

class Scope : virtual public ::IceDelegate::Tartarus::iface::DHCP::Scope,
              virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::Tartarus::iface::DHCP::StrStrMap options(const ::Ice::Context*);

    virtual void setOption(const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual void unsetOption(const ::std::string&, const ::Ice::Context*);
};

class Host : virtual public ::IceDelegate::Tartarus::iface::DHCP::Host,
             virtual public ::IceDelegateD::Tartarus::iface::DHCP::Scope
{
public:

    virtual ::std::string name(const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::HostId id(const ::Ice::Context*);
};

class Range : virtual public ::IceDelegate::Tartarus::iface::DHCP::Range,
              virtual public ::IceDelegateD::Tartarus::iface::DHCP::Scope
{
public:

    virtual ::std::string id(const ::Ice::Context*);

    virtual ::Ice::Int caps(const ::Ice::Context*);

    virtual void setCaps(::Ice::Int, const ::Ice::Context*);

    virtual void addrs(::std::string&, ::std::string&, const ::Ice::Context*);
};

class Subnet : virtual public ::IceDelegate::Tartarus::iface::DHCP::Subnet,
               virtual public ::IceDelegateD::Tartarus::iface::DHCP::Scope
{
public:

    virtual ::std::string id(const ::Ice::Context*);

    virtual ::std::string cidr(const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::RangeSeq ranges(const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::RangePrx getRange(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::RangePrx addRange(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Context*);

    virtual void delRange(const ::std::string&, const ::Ice::Context*);
};

class Server : virtual public ::IceDelegate::Tartarus::iface::DHCP::Server,
               virtual public ::IceDelegateD::Tartarus::iface::DHCP::Scope
{
public:

    virtual ::Tartarus::iface::DHCP::SubnetSeq subnets(const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::SubnetPrx findSubnet(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::SubnetPrx addSubnet(const ::std::string&, const ::Ice::Context*);

    virtual void delSubnet(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::HostSeq hosts(const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::HostPrx getHost(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::HostPrx addHost(const ::std::string&, const ::Tartarus::iface::DHCP::HostId&, const ::Ice::Context*);

    virtual void delHost(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string&, const ::Ice::Context*);

    virtual bool isConfigured(const ::Ice::Context*);

    virtual void reset(const ::Ice::Context*);
};

class Daemon : virtual public ::IceDelegate::Tartarus::iface::DHCP::Daemon,
               virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void start(const ::Ice::Context*);

    virtual void stop(const ::Ice::Context*);

    virtual bool running(const ::Ice::Context*);
};

}

}

}

}

namespace Tartarus
{

namespace iface
{

namespace DHCP
{

class Scope : virtual public ::Ice::Object
{
public:

    typedef ScopePrx ProxyType;
    typedef ScopePtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Tartarus::iface::DHCP::StrStrMap options(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___options(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setOption(const ::std::string&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setOption(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void unsetOption(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___unsetOption(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class Host : virtual public ::Tartarus::iface::DHCP::Scope
{
public:

    typedef HostPrx ProxyType;
    typedef HostPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::std::string name(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___name(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DHCP::HostId id(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___id(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class Range : virtual public ::Tartarus::iface::DHCP::Scope
{
public:

    typedef RangePrx ProxyType;
    typedef RangePtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::std::string id(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___id(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Int caps(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___caps(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setCaps(::Ice::Int, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setCaps(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void addrs(::std::string&, ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___addrs(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class Subnet : virtual public ::Tartarus::iface::DHCP::Scope
{
public:

    typedef SubnetPrx ProxyType;
    typedef SubnetPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::std::string id(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___id(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::std::string cidr(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___cidr(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DHCP::RangeSeq ranges(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___ranges(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DHCP::RangePrx getRange(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getRange(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___findRange(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DHCP::RangePrx addRange(const ::std::string&, const ::std::string&, ::Ice::Int, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___addRange(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void delRange(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___delRange(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class Server : virtual public ::Tartarus::iface::DHCP::Scope
{
public:

    typedef ServerPrx ProxyType;
    typedef ServerPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Tartarus::iface::DHCP::SubnetSeq subnets(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___subnets(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DHCP::SubnetPrx findSubnet(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___findSubnet(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DHCP::SubnetPrx addSubnet(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___addSubnet(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void delSubnet(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___delSubnet(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DHCP::HostSeq hosts(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___hosts(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DHCP::HostPrx getHost(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getHost(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DHCP::HostPrx addHost(const ::std::string&, const ::Tartarus::iface::DHCP::HostId&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___addHost(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void delHost(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___delHost(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DHCP::RangePrx findRange(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___findRange(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual bool isConfigured(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___isConfigured(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void reset(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___reset(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class Daemon : virtual public ::Ice::Object
{
public:

    typedef DaemonPrx ProxyType;
    typedef DaemonPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void start(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___start(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void stop(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___stop(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual bool running(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___running(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

}

}

}

#endif
