// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `DNS.ice'

#ifndef ___usr_src_RPM_BUILD_Tartarus_0_8_3__waf_build_default_slice_DNS_DNS_h__
#define ___usr_src_RPM_BUILD_Tartarus_0_8_3__waf_build_default_slice_DNS_DNS_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <core/exceptions.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace Tartarus
{

namespace iface
{

namespace DNS
{

class Zone;

class Server;

}

}

}

}

namespace Tartarus
{

namespace iface
{

namespace DNS
{

class Zone;
bool operator==(const Zone&, const Zone&);
bool operator<(const Zone&, const Zone&);

class Server;
bool operator==(const Server&, const Server&);
bool operator<(const Server&, const Server&);

}

}

}

namespace IceInternal
{

::Ice::Object* upCast(::Tartarus::iface::DNS::Zone*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::DNS::Zone*);

::Ice::Object* upCast(::Tartarus::iface::DNS::Server*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::DNS::Server*);

}

namespace Tartarus
{

namespace iface
{

namespace DNS
{

typedef ::IceInternal::Handle< ::Tartarus::iface::DNS::Zone> ZonePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::DNS::Zone> ZonePrx;

void __read(::IceInternal::BasicStream*, ZonePrx&);
void __patch__ZonePtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::Tartarus::iface::DNS::Server> ServerPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::DNS::Server> ServerPrx;

void __read(::IceInternal::BasicStream*, ServerPrx&);
void __patch__ServerPtr(void*, ::Ice::ObjectPtr&);

}

}

}

namespace Tartarus
{

namespace iface
{

namespace DNS
{

enum RecordType
{
    A,
    AAAA,
    AFSDB,
    CERT,
    CNAME,
    DNSKEY,
    DS,
    HINFO,
    KEY,
    LOC,
    MX,
    NAPTR,
    NS,
    NSEC,
    PTR,
    RP,
    RRSIG,
    SPF,
    SSHFP,
    SRV,
    TXT
};

void __write(::IceInternal::BasicStream*, RecordType);
void __read(::IceInternal::BasicStream*, RecordType&);

struct Record
{
    ::std::string name;
    ::Tartarus::iface::DNS::RecordType type;
    ::std::string data;
    ::Ice::Long ttl;
    ::Ice::Long prio;

    bool operator==(const Record&) const;
    bool operator<(const Record&) const;
    bool operator!=(const Record& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const Record& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const Record& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const Record& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::Tartarus::iface::DNS::Record> RecordSeq;
void __writeRecordSeq(::IceInternal::BasicStream*, const ::Tartarus::iface::DNS::Record*, const ::Tartarus::iface::DNS::Record*);
void __readRecordSeq(::IceInternal::BasicStream*, RecordSeq&);

struct SOARecord
{
    ::std::string nameserver;
    ::std::string hostmaster;
    ::Ice::Long serial;
    ::Ice::Long refresh;
    ::Ice::Long retry;
    ::Ice::Long expire;
    ::Ice::Long ttl;

    bool operator==(const SOARecord&) const;
    bool operator<(const SOARecord&) const;
    bool operator!=(const SOARecord& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const SOARecord& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const SOARecord& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const SOARecord& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::Tartarus::iface::DNS::ZonePrx> ZoneSeq;
void __writeZoneSeq(::IceInternal::BasicStream*, const ::Tartarus::iface::DNS::ZonePrx*, const ::Tartarus::iface::DNS::ZonePrx*);
void __readZoneSeq(::IceInternal::BasicStream*, ZoneSeq&);

struct ServerOption
{
    ::std::string name;
    ::std::string value;

    bool operator==(const ServerOption&) const;
    bool operator<(const ServerOption&) const;
    bool operator!=(const ServerOption& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const ServerOption& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const ServerOption& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const ServerOption& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::Tartarus::iface::DNS::ServerOption> ServerOptionSeq;
void __writeServerOptionSeq(::IceInternal::BasicStream*, const ::Tartarus::iface::DNS::ServerOption*, const ::Tartarus::iface::DNS::ServerOption*);
void __readServerOptionSeq(::IceInternal::BasicStream*, ServerOptionSeq&);

}

}

}

namespace IceProxy
{

namespace Tartarus
{

namespace iface
{

namespace DNS
{

class Zone : virtual public ::IceProxy::Ice::Object
{
public:

    ::std::string getName()
    {
        return getName(0);
    }
    ::std::string getName(const ::Ice::Context& __ctx)
    {
        return getName(&__ctx);
    }
    
private:

    ::std::string getName(const ::Ice::Context*);
    
public:

    void addRecord(const ::Tartarus::iface::DNS::Record& r)
    {
        addRecord(r, 0);
    }
    void addRecord(const ::Tartarus::iface::DNS::Record& r, const ::Ice::Context& __ctx)
    {
        addRecord(r, &__ctx);
    }
    
private:

    void addRecord(const ::Tartarus::iface::DNS::Record&, const ::Ice::Context*);
    
public:

    void addRecords(const ::Tartarus::iface::DNS::RecordSeq& rs)
    {
        addRecords(rs, 0);
    }
    void addRecords(const ::Tartarus::iface::DNS::RecordSeq& rs, const ::Ice::Context& __ctx)
    {
        addRecords(rs, &__ctx);
    }
    
private:

    void addRecords(const ::Tartarus::iface::DNS::RecordSeq&, const ::Ice::Context*);
    
public:

    void clearAll()
    {
        clearAll(0);
    }
    void clearAll(const ::Ice::Context& __ctx)
    {
        clearAll(&__ctx);
    }
    
private:

    void clearAll(const ::Ice::Context*);
    
public:

    void replaceRecord(const ::Tartarus::iface::DNS::Record& oldr, const ::Tartarus::iface::DNS::Record& newr)
    {
        replaceRecord(oldr, newr, 0);
    }
    void replaceRecord(const ::Tartarus::iface::DNS::Record& oldr, const ::Tartarus::iface::DNS::Record& newr, const ::Ice::Context& __ctx)
    {
        replaceRecord(oldr, newr, &__ctx);
    }
    
private:

    void replaceRecord(const ::Tartarus::iface::DNS::Record&, const ::Tartarus::iface::DNS::Record&, const ::Ice::Context*);
    
public:

    void dropRecord(const ::Tartarus::iface::DNS::Record& r)
    {
        dropRecord(r, 0);
    }
    void dropRecord(const ::Tartarus::iface::DNS::Record& r, const ::Ice::Context& __ctx)
    {
        dropRecord(r, &__ctx);
    }
    
private:

    void dropRecord(const ::Tartarus::iface::DNS::Record&, const ::Ice::Context*);
    
public:

    ::Ice::Long countRecords()
    {
        return countRecords(0);
    }
    ::Ice::Long countRecords(const ::Ice::Context& __ctx)
    {
        return countRecords(&__ctx);
    }
    
private:

    ::Ice::Long countRecords(const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DNS::RecordSeq getRecords(::Ice::Long limit, ::Ice::Long offset)
    {
        return getRecords(limit, offset, 0);
    }
    ::Tartarus::iface::DNS::RecordSeq getRecords(::Ice::Long limit, ::Ice::Long offset, const ::Ice::Context& __ctx)
    {
        return getRecords(limit, offset, &__ctx);
    }
    
private:

    ::Tartarus::iface::DNS::RecordSeq getRecords(::Ice::Long, ::Ice::Long, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DNS::RecordSeq findRecords(const ::std::string& phrase, ::Ice::Long limit)
    {
        return findRecords(phrase, limit, 0);
    }
    ::Tartarus::iface::DNS::RecordSeq findRecords(const ::std::string& phrase, ::Ice::Long limit, const ::Ice::Context& __ctx)
    {
        return findRecords(phrase, limit, &__ctx);
    }
    
private:

    ::Tartarus::iface::DNS::RecordSeq findRecords(const ::std::string&, ::Ice::Long, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DNS::SOARecord getSOA()
    {
        return getSOA(0);
    }
    ::Tartarus::iface::DNS::SOARecord getSOA(const ::Ice::Context& __ctx)
    {
        return getSOA(&__ctx);
    }
    
private:

    ::Tartarus::iface::DNS::SOARecord getSOA(const ::Ice::Context*);
    
public:

    void setSOA(const ::Tartarus::iface::DNS::SOARecord& soar)
    {
        setSOA(soar, 0);
    }
    void setSOA(const ::Tartarus::iface::DNS::SOARecord& soar, const ::Ice::Context& __ctx)
    {
        setSOA(soar, &__ctx);
    }
    
private:

    void setSOA(const ::Tartarus::iface::DNS::SOARecord&, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<Zone> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Zone> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Zone*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Zone*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class Server : virtual public ::IceProxy::Ice::Object
{
public:

    ::Tartarus::iface::DNS::ZoneSeq getZones()
    {
        return getZones(0);
    }
    ::Tartarus::iface::DNS::ZoneSeq getZones(const ::Ice::Context& __ctx)
    {
        return getZones(&__ctx);
    }
    
private:

    ::Tartarus::iface::DNS::ZoneSeq getZones(const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DNS::ZonePrx getZone(const ::std::string& name)
    {
        return getZone(name, 0);
    }
    ::Tartarus::iface::DNS::ZonePrx getZone(const ::std::string& name, const ::Ice::Context& __ctx)
    {
        return getZone(name, &__ctx);
    }
    
private:

    ::Tartarus::iface::DNS::ZonePrx getZone(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DNS::ZonePrx createZone(const ::std::string& name, const ::Tartarus::iface::DNS::SOARecord& soar)
    {
        return createZone(name, soar, 0);
    }
    ::Tartarus::iface::DNS::ZonePrx createZone(const ::std::string& name, const ::Tartarus::iface::DNS::SOARecord& soar, const ::Ice::Context& __ctx)
    {
        return createZone(name, soar, &__ctx);
    }
    
private:

    ::Tartarus::iface::DNS::ZonePrx createZone(const ::std::string&, const ::Tartarus::iface::DNS::SOARecord&, const ::Ice::Context*);
    
public:

    void deleteZone(const ::std::string& name)
    {
        deleteZone(name, 0);
    }
    void deleteZone(const ::std::string& name, const ::Ice::Context& __ctx)
    {
        deleteZone(name, &__ctx);
    }
    
private:

    void deleteZone(const ::std::string&, const ::Ice::Context*);
    
public:

    void deleteZoneByRef(const ::Tartarus::iface::DNS::ZonePrx& proxy)
    {
        deleteZoneByRef(proxy, 0);
    }
    void deleteZoneByRef(const ::Tartarus::iface::DNS::ZonePrx& proxy, const ::Ice::Context& __ctx)
    {
        deleteZoneByRef(proxy, &__ctx);
    }
    
private:

    void deleteZoneByRef(const ::Tartarus::iface::DNS::ZonePrx&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::DNS::ServerOptionSeq getOptions()
    {
        return getOptions(0);
    }
    ::Tartarus::iface::DNS::ServerOptionSeq getOptions(const ::Ice::Context& __ctx)
    {
        return getOptions(&__ctx);
    }
    
private:

    ::Tartarus::iface::DNS::ServerOptionSeq getOptions(const ::Ice::Context*);
    
public:

    void setOptions(const ::Tartarus::iface::DNS::ServerOptionSeq& opts)
    {
        setOptions(opts, 0);
    }
    void setOptions(const ::Tartarus::iface::DNS::ServerOptionSeq& opts, const ::Ice::Context& __ctx)
    {
        setOptions(opts, &__ctx);
    }
    
private:

    void setOptions(const ::Tartarus::iface::DNS::ServerOptionSeq&, const ::Ice::Context*);
    
public:

    void changeOptions(const ::Tartarus::iface::DNS::ServerOptionSeq& opts)
    {
        changeOptions(opts, 0);
    }
    void changeOptions(const ::Tartarus::iface::DNS::ServerOptionSeq& opts, const ::Ice::Context& __ctx)
    {
        changeOptions(opts, &__ctx);
    }
    
private:

    void changeOptions(const ::Tartarus::iface::DNS::ServerOptionSeq&, const ::Ice::Context*);
    
public:

    void updateHost(const ::std::string& hostname, const ::std::string& addr)
    {
        updateHost(hostname, addr, 0);
    }
    void updateHost(const ::std::string& hostname, const ::std::string& addr, const ::Ice::Context& __ctx)
    {
        updateHost(hostname, addr, &__ctx);
    }
    
private:

    void updateHost(const ::std::string&, const ::std::string&, const ::Ice::Context*);
    
public:

    void updateThisHost()
    {
        updateThisHost(0);
    }
    void updateThisHost(const ::Ice::Context& __ctx)
    {
        updateThisHost(&__ctx);
    }
    
private:

    void updateThisHost(const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<Server> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Server> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Server*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Server*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

}

}

}

}

namespace IceDelegate
{

namespace Tartarus
{

namespace iface
{

namespace DNS
{

class Zone : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::std::string getName(const ::Ice::Context*) = 0;

    virtual void addRecord(const ::Tartarus::iface::DNS::Record&, const ::Ice::Context*) = 0;

    virtual void addRecords(const ::Tartarus::iface::DNS::RecordSeq&, const ::Ice::Context*) = 0;

    virtual void clearAll(const ::Ice::Context*) = 0;

    virtual void replaceRecord(const ::Tartarus::iface::DNS::Record&, const ::Tartarus::iface::DNS::Record&, const ::Ice::Context*) = 0;

    virtual void dropRecord(const ::Tartarus::iface::DNS::Record&, const ::Ice::Context*) = 0;

    virtual ::Ice::Long countRecords(const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DNS::RecordSeq getRecords(::Ice::Long, ::Ice::Long, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DNS::RecordSeq findRecords(const ::std::string&, ::Ice::Long, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DNS::SOARecord getSOA(const ::Ice::Context*) = 0;

    virtual void setSOA(const ::Tartarus::iface::DNS::SOARecord&, const ::Ice::Context*) = 0;
};

class Server : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::Tartarus::iface::DNS::ZoneSeq getZones(const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DNS::ZonePrx getZone(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DNS::ZonePrx createZone(const ::std::string&, const ::Tartarus::iface::DNS::SOARecord&, const ::Ice::Context*) = 0;

    virtual void deleteZone(const ::std::string&, const ::Ice::Context*) = 0;

    virtual void deleteZoneByRef(const ::Tartarus::iface::DNS::ZonePrx&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::DNS::ServerOptionSeq getOptions(const ::Ice::Context*) = 0;

    virtual void setOptions(const ::Tartarus::iface::DNS::ServerOptionSeq&, const ::Ice::Context*) = 0;

    virtual void changeOptions(const ::Tartarus::iface::DNS::ServerOptionSeq&, const ::Ice::Context*) = 0;

    virtual void updateHost(const ::std::string&, const ::std::string&, const ::Ice::Context*) = 0;

    virtual void updateThisHost(const ::Ice::Context*) = 0;
};

}

}

}

}

namespace IceDelegateM
{

namespace Tartarus
{

namespace iface
{

namespace DNS
{

class Zone : virtual public ::IceDelegate::Tartarus::iface::DNS::Zone,
             virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::std::string getName(const ::Ice::Context*);

    virtual void addRecord(const ::Tartarus::iface::DNS::Record&, const ::Ice::Context*);

    virtual void addRecords(const ::Tartarus::iface::DNS::RecordSeq&, const ::Ice::Context*);

    virtual void clearAll(const ::Ice::Context*);

    virtual void replaceRecord(const ::Tartarus::iface::DNS::Record&, const ::Tartarus::iface::DNS::Record&, const ::Ice::Context*);

    virtual void dropRecord(const ::Tartarus::iface::DNS::Record&, const ::Ice::Context*);

    virtual ::Ice::Long countRecords(const ::Ice::Context*);

    virtual ::Tartarus::iface::DNS::RecordSeq getRecords(::Ice::Long, ::Ice::Long, const ::Ice::Context*);

    virtual ::Tartarus::iface::DNS::RecordSeq findRecords(const ::std::string&, ::Ice::Long, const ::Ice::Context*);

    virtual ::Tartarus::iface::DNS::SOARecord getSOA(const ::Ice::Context*);

    virtual void setSOA(const ::Tartarus::iface::DNS::SOARecord&, const ::Ice::Context*);
};

class Server : virtual public ::IceDelegate::Tartarus::iface::DNS::Server,
               virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::Tartarus::iface::DNS::ZoneSeq getZones(const ::Ice::Context*);

    virtual ::Tartarus::iface::DNS::ZonePrx getZone(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DNS::ZonePrx createZone(const ::std::string&, const ::Tartarus::iface::DNS::SOARecord&, const ::Ice::Context*);

    virtual void deleteZone(const ::std::string&, const ::Ice::Context*);

    virtual void deleteZoneByRef(const ::Tartarus::iface::DNS::ZonePrx&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DNS::ServerOptionSeq getOptions(const ::Ice::Context*);

    virtual void setOptions(const ::Tartarus::iface::DNS::ServerOptionSeq&, const ::Ice::Context*);

    virtual void changeOptions(const ::Tartarus::iface::DNS::ServerOptionSeq&, const ::Ice::Context*);

    virtual void updateHost(const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual void updateThisHost(const ::Ice::Context*);
};

}

}

}

}

namespace IceDelegateD
{

namespace Tartarus
{

namespace iface
{

namespace DNS
{

class Zone : virtual public ::IceDelegate::Tartarus::iface::DNS::Zone,
             virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::std::string getName(const ::Ice::Context*);

    virtual void addRecord(const ::Tartarus::iface::DNS::Record&, const ::Ice::Context*);

    virtual void addRecords(const ::Tartarus::iface::DNS::RecordSeq&, const ::Ice::Context*);

    virtual void clearAll(const ::Ice::Context*);

    virtual void replaceRecord(const ::Tartarus::iface::DNS::Record&, const ::Tartarus::iface::DNS::Record&, const ::Ice::Context*);

    virtual void dropRecord(const ::Tartarus::iface::DNS::Record&, const ::Ice::Context*);

    virtual ::Ice::Long countRecords(const ::Ice::Context*);

    virtual ::Tartarus::iface::DNS::RecordSeq getRecords(::Ice::Long, ::Ice::Long, const ::Ice::Context*);

    virtual ::Tartarus::iface::DNS::RecordSeq findRecords(const ::std::string&, ::Ice::Long, const ::Ice::Context*);

    virtual ::Tartarus::iface::DNS::SOARecord getSOA(const ::Ice::Context*);

    virtual void setSOA(const ::Tartarus::iface::DNS::SOARecord&, const ::Ice::Context*);
};

class Server : virtual public ::IceDelegate::Tartarus::iface::DNS::Server,
               virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::Tartarus::iface::DNS::ZoneSeq getZones(const ::Ice::Context*);

    virtual ::Tartarus::iface::DNS::ZonePrx getZone(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DNS::ZonePrx createZone(const ::std::string&, const ::Tartarus::iface::DNS::SOARecord&, const ::Ice::Context*);

    virtual void deleteZone(const ::std::string&, const ::Ice::Context*);

    virtual void deleteZoneByRef(const ::Tartarus::iface::DNS::ZonePrx&, const ::Ice::Context*);

    virtual ::Tartarus::iface::DNS::ServerOptionSeq getOptions(const ::Ice::Context*);

    virtual void setOptions(const ::Tartarus::iface::DNS::ServerOptionSeq&, const ::Ice::Context*);

    virtual void changeOptions(const ::Tartarus::iface::DNS::ServerOptionSeq&, const ::Ice::Context*);

    virtual void updateHost(const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual void updateThisHost(const ::Ice::Context*);
};

}

}

}

}

namespace Tartarus
{

namespace iface
{

namespace DNS
{

class Zone : virtual public ::Ice::Object
{
public:

    typedef ZonePrx ProxyType;
    typedef ZonePtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::std::string getName(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getName(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void addRecord(const ::Tartarus::iface::DNS::Record&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___addRecord(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void addRecords(const ::Tartarus::iface::DNS::RecordSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___addRecords(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void clearAll(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___clearAll(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void replaceRecord(const ::Tartarus::iface::DNS::Record&, const ::Tartarus::iface::DNS::Record&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___replaceRecord(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void dropRecord(const ::Tartarus::iface::DNS::Record&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___dropRecord(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Long countRecords(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___countRecords(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DNS::RecordSeq getRecords(::Ice::Long, ::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getRecords(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DNS::RecordSeq findRecords(const ::std::string&, ::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___findRecords(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DNS::SOARecord getSOA(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getSOA(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setSOA(const ::Tartarus::iface::DNS::SOARecord&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setSOA(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class Server : virtual public ::Ice::Object
{
public:

    typedef ServerPrx ProxyType;
    typedef ServerPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Tartarus::iface::DNS::ZoneSeq getZones(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getZones(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DNS::ZonePrx getZone(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getZone(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DNS::ZonePrx createZone(const ::std::string&, const ::Tartarus::iface::DNS::SOARecord&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___createZone(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void deleteZone(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___deleteZone(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void deleteZoneByRef(const ::Tartarus::iface::DNS::ZonePrx&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___deleteZoneByRef(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::DNS::ServerOptionSeq getOptions(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getOptions(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setOptions(const ::Tartarus::iface::DNS::ServerOptionSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setOptions(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void changeOptions(const ::Tartarus::iface::DNS::ServerOptionSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___changeOptions(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void updateHost(const ::std::string&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___updateHost(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void updateThisHost(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___updateThisHost(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

}

}

}

#endif
