// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `kadmin.ice'

#ifndef ___usr_src_RPM_BUILD_Tartarus_0_8_3__waf_build_default_slice_Kerberos_kadmin_h__
#define ___usr_src_RPM_BUILD_Tartarus_0_8_3__waf_build_default_slice_Kerberos_kadmin_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <core/exceptions.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace Tartarus
{

namespace iface
{

namespace Kerberos
{

class Kadmin;

}

}

}

}

namespace Tartarus
{

namespace iface
{

namespace Kerberos
{

class Kadmin;
bool operator==(const Kadmin&, const Kadmin&);
bool operator<(const Kadmin&, const Kadmin&);

}

}

}

namespace IceInternal
{

::Ice::Object* upCast(::Tartarus::iface::Kerberos::Kadmin*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::Kerberos::Kadmin*);

}

namespace Tartarus
{

namespace iface
{

namespace Kerberos
{

typedef ::IceInternal::Handle< ::Tartarus::iface::Kerberos::Kadmin> KadminPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::Kerberos::Kadmin> KadminPrx;

void __read(::IceInternal::BasicStream*, KadminPrx&);
void __patch__KadminPtr(void*, ::Ice::ObjectPtr&);

}

}

}

namespace Tartarus
{

namespace iface
{

namespace Kerberos
{

class KadminError : public ::Tartarus::iface::core::DBError
{
public:

    KadminError() {}
    KadminError(const ::std::string&, const ::std::string&, ::Ice::Int);
    virtual ~KadminError() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::Ice::Int code;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static KadminError __KadminError_init;

typedef ::std::vector< ::Ice::Byte> KeyData;

typedef ::std::vector< ::std::string> PrincSeq;

struct Key
{
    ::Ice::Long kvno;
    ::Ice::Int enctype;
    ::Tartarus::iface::Kerberos::KeyData data;

    bool operator==(const Key&) const;
    bool operator<(const Key&) const;
    bool operator!=(const Key& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const Key& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const Key& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const Key& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

typedef ::std::vector< ::Tartarus::iface::Kerberos::Key> KeySeq;
void __writeKeySeq(::IceInternal::BasicStream*, const ::Tartarus::iface::Kerberos::Key*, const ::Tartarus::iface::Kerberos::Key*);
void __readKeySeq(::IceInternal::BasicStream*, KeySeq&);

struct PrincKeys
{
    ::std::string name;
    ::Tartarus::iface::Kerberos::KeySeq keys;

    bool operator==(const PrincKeys&) const;
    bool operator<(const PrincKeys&) const;
    bool operator!=(const PrincKeys& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const PrincKeys& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const PrincKeys& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const PrincKeys& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

}

}

}

namespace IceProxy
{

namespace Tartarus
{

namespace iface
{

namespace Kerberos
{

class Kadmin : virtual public ::IceProxy::Ice::Object
{
public:

    ::Tartarus::iface::Kerberos::PrincKeys getPrincKeys(const ::std::string& name)
    {
        return getPrincKeys(name, 0);
    }
    ::Tartarus::iface::Kerberos::PrincKeys getPrincKeys(const ::std::string& name, const ::Ice::Context& __ctx)
    {
        return getPrincKeys(name, &__ctx);
    }
    
private:

    ::Tartarus::iface::Kerberos::PrincKeys getPrincKeys(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::Kerberos::PrincKeys createServicePrincipal(const ::std::string& service, const ::std::string& host)
    {
        return createServicePrincipal(service, host, 0);
    }
    ::Tartarus::iface::Kerberos::PrincKeys createServicePrincipal(const ::std::string& service, const ::std::string& host, const ::Ice::Context& __ctx)
    {
        return createServicePrincipal(service, host, &__ctx);
    }
    
private:

    ::Tartarus::iface::Kerberos::PrincKeys createServicePrincipal(const ::std::string&, const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::Kerberos::PrincKeys randomizeServicePrincKeys(const ::std::string& service, const ::std::string& host)
    {
        return randomizeServicePrincKeys(service, host, 0);
    }
    ::Tartarus::iface::Kerberos::PrincKeys randomizeServicePrincKeys(const ::std::string& service, const ::std::string& host, const ::Ice::Context& __ctx)
    {
        return randomizeServicePrincKeys(service, host, &__ctx);
    }
    
private:

    ::Tartarus::iface::Kerberos::PrincKeys randomizeServicePrincKeys(const ::std::string&, const ::std::string&, const ::Ice::Context*);
    
public:

    ::std::string createPrincipal(const ::std::string& name, const ::std::string& password)
    {
        return createPrincipal(name, password, 0);
    }
    ::std::string createPrincipal(const ::std::string& name, const ::std::string& password, const ::Ice::Context& __ctx)
    {
        return createPrincipal(name, password, &__ctx);
    }
    
private:

    ::std::string createPrincipal(const ::std::string&, const ::std::string&, const ::Ice::Context*);
    
public:

    ::std::string changePrincPassword(const ::std::string& name, const ::std::string& password)
    {
        return changePrincPassword(name, password, 0);
    }
    ::std::string changePrincPassword(const ::std::string& name, const ::std::string& password, const ::Ice::Context& __ctx)
    {
        return changePrincPassword(name, password, &__ctx);
    }
    
private:

    ::std::string changePrincPassword(const ::std::string&, const ::std::string&, const ::Ice::Context*);
    
public:

    void deletePrincipal(const ::std::string& name)
    {
        deletePrincipal(name, 0);
    }
    void deletePrincipal(const ::std::string& name, const ::Ice::Context& __ctx)
    {
        deletePrincipal(name, &__ctx);
    }
    
private:

    void deletePrincipal(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::Kerberos::PrincSeq listPrincs(const ::std::string& expr)
    {
        return listPrincs(expr, 0);
    }
    ::Tartarus::iface::Kerberos::PrincSeq listPrincs(const ::std::string& expr, const ::Ice::Context& __ctx)
    {
        return listPrincs(expr, &__ctx);
    }
    
private:

    ::Tartarus::iface::Kerberos::PrincSeq listPrincs(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::Kerberos::PrincSeq listAllPrincs()
    {
        return listAllPrincs(0);
    }
    ::Tartarus::iface::Kerberos::PrincSeq listAllPrincs(const ::Ice::Context& __ctx)
    {
        return listAllPrincs(&__ctx);
    }
    
private:

    ::Tartarus::iface::Kerberos::PrincSeq listAllPrincs(const ::Ice::Context*);
    
public:

    bool isPrincEnabled(const ::std::string& name)
    {
        return isPrincEnabled(name, 0);
    }
    bool isPrincEnabled(const ::std::string& name, const ::Ice::Context& __ctx)
    {
        return isPrincEnabled(name, &__ctx);
    }
    
private:

    bool isPrincEnabled(const ::std::string&, const ::Ice::Context*);
    
public:

    void setPrincEnabled(const ::std::string& name, bool enable)
    {
        setPrincEnabled(name, enable, 0);
    }
    void setPrincEnabled(const ::std::string& name, bool enable, const ::Ice::Context& __ctx)
    {
        setPrincEnabled(name, enable, &__ctx);
    }
    
private:

    void setPrincEnabled(const ::std::string&, bool, const ::Ice::Context*);
    
public:

    void reGenerateDatabase(const ::std::string& password)
    {
        reGenerateDatabase(password, 0);
    }
    void reGenerateDatabase(const ::std::string& password, const ::Ice::Context& __ctx)
    {
        reGenerateDatabase(password, &__ctx);
    }
    
private:

    void reGenerateDatabase(const ::std::string&, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<Kadmin> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Kadmin> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Kadmin*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Kadmin*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

}

}

}

}

namespace IceDelegate
{

namespace Tartarus
{

namespace iface
{

namespace Kerberos
{

class Kadmin : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::Tartarus::iface::Kerberos::PrincKeys getPrincKeys(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::Kerberos::PrincKeys createServicePrincipal(const ::std::string&, const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::Kerberos::PrincKeys randomizeServicePrincKeys(const ::std::string&, const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::std::string createPrincipal(const ::std::string&, const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::std::string changePrincPassword(const ::std::string&, const ::std::string&, const ::Ice::Context*) = 0;

    virtual void deletePrincipal(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::Kerberos::PrincSeq listPrincs(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::Kerberos::PrincSeq listAllPrincs(const ::Ice::Context*) = 0;

    virtual bool isPrincEnabled(const ::std::string&, const ::Ice::Context*) = 0;

    virtual void setPrincEnabled(const ::std::string&, bool, const ::Ice::Context*) = 0;

    virtual void reGenerateDatabase(const ::std::string&, const ::Ice::Context*) = 0;
};

}

}

}

}

namespace IceDelegateM
{

namespace Tartarus
{

namespace iface
{

namespace Kerberos
{

class Kadmin : virtual public ::IceDelegate::Tartarus::iface::Kerberos::Kadmin,
               virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::Tartarus::iface::Kerberos::PrincKeys getPrincKeys(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::Kerberos::PrincKeys createServicePrincipal(const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::Kerberos::PrincKeys randomizeServicePrincKeys(const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual ::std::string createPrincipal(const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual ::std::string changePrincPassword(const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual void deletePrincipal(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::Kerberos::PrincSeq listPrincs(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::Kerberos::PrincSeq listAllPrincs(const ::Ice::Context*);

    virtual bool isPrincEnabled(const ::std::string&, const ::Ice::Context*);

    virtual void setPrincEnabled(const ::std::string&, bool, const ::Ice::Context*);

    virtual void reGenerateDatabase(const ::std::string&, const ::Ice::Context*);
};

}

}

}

}

namespace IceDelegateD
{

namespace Tartarus
{

namespace iface
{

namespace Kerberos
{

class Kadmin : virtual public ::IceDelegate::Tartarus::iface::Kerberos::Kadmin,
               virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::Tartarus::iface::Kerberos::PrincKeys getPrincKeys(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::Kerberos::PrincKeys createServicePrincipal(const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::Kerberos::PrincKeys randomizeServicePrincKeys(const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual ::std::string createPrincipal(const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual ::std::string changePrincPassword(const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual void deletePrincipal(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::Kerberos::PrincSeq listPrincs(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::Kerberos::PrincSeq listAllPrincs(const ::Ice::Context*);

    virtual bool isPrincEnabled(const ::std::string&, const ::Ice::Context*);

    virtual void setPrincEnabled(const ::std::string&, bool, const ::Ice::Context*);

    virtual void reGenerateDatabase(const ::std::string&, const ::Ice::Context*);
};

}

}

}

}

namespace Tartarus
{

namespace iface
{

namespace Kerberos
{

class Kadmin : virtual public ::Ice::Object
{
public:

    typedef KadminPrx ProxyType;
    typedef KadminPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Tartarus::iface::Kerberos::PrincKeys getPrincKeys(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getPrincKeys(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::Kerberos::PrincKeys createServicePrincipal(const ::std::string&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___createServicePrincipal(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::Kerberos::PrincKeys randomizeServicePrincKeys(const ::std::string&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___randomizeServicePrincKeys(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::std::string createPrincipal(const ::std::string&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___createPrincipal(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::std::string changePrincPassword(const ::std::string&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___changePrincPassword(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void deletePrincipal(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___deletePrincipal(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::Kerberos::PrincSeq listPrincs(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___listPrincs(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::Kerberos::PrincSeq listAllPrincs(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___listAllPrincs(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual bool isPrincEnabled(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___isPrincEnabled(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setPrincEnabled(const ::std::string&, bool, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setPrincEnabled(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void reGenerateDatabase(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___reGenerateDatabase(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

}

}

}

#endif
