// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `SysDB.ice'

#ifndef ___usr_src_RPM_BUILD_Tartarus_0_8_3__waf_build_default_slice_SysDB_SysDB_h__
#define ___usr_src_RPM_BUILD_Tartarus_0_8_3__waf_build_default_slice_SysDB_SysDB_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/Incoming.h>
#include <Ice/Direct.h>
#include <Ice/UserExceptionFactory.h>
#include <Ice/FactoryTable.h>
#include <Ice/StreamF.h>
#include <core/exceptions.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace Tartarus
{

namespace iface
{

namespace SysDB
{

class UserReader;

class UserManager;

class GroupReader;

class GroupManager;

}

}

}

}

namespace Tartarus
{

namespace iface
{

namespace SysDB
{

class UserReader;
bool operator==(const UserReader&, const UserReader&);
bool operator<(const UserReader&, const UserReader&);

class UserManager;
bool operator==(const UserManager&, const UserManager&);
bool operator<(const UserManager&, const UserManager&);

class GroupReader;
bool operator==(const GroupReader&, const GroupReader&);
bool operator<(const GroupReader&, const GroupReader&);

class GroupManager;
bool operator==(const GroupManager&, const GroupManager&);
bool operator<(const GroupManager&, const GroupManager&);

}

}

}

namespace IceInternal
{

::Ice::Object* upCast(::Tartarus::iface::SysDB::UserReader*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::SysDB::UserReader*);

::Ice::Object* upCast(::Tartarus::iface::SysDB::UserManager*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::SysDB::UserManager*);

::Ice::Object* upCast(::Tartarus::iface::SysDB::GroupReader*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::SysDB::GroupReader*);

::Ice::Object* upCast(::Tartarus::iface::SysDB::GroupManager*);
::IceProxy::Ice::Object* upCast(::IceProxy::Tartarus::iface::SysDB::GroupManager*);

}

namespace Tartarus
{

namespace iface
{

namespace SysDB
{

typedef ::IceInternal::Handle< ::Tartarus::iface::SysDB::UserReader> UserReaderPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::SysDB::UserReader> UserReaderPrx;

void __read(::IceInternal::BasicStream*, UserReaderPrx&);
void __patch__UserReaderPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::Tartarus::iface::SysDB::UserManager> UserManagerPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::SysDB::UserManager> UserManagerPrx;

void __read(::IceInternal::BasicStream*, UserManagerPrx&);
void __patch__UserManagerPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::Tartarus::iface::SysDB::GroupReader> GroupReaderPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::SysDB::GroupReader> GroupReaderPrx;

void __read(::IceInternal::BasicStream*, GroupReaderPrx&);
void __patch__GroupReaderPtr(void*, ::Ice::ObjectPtr&);

typedef ::IceInternal::Handle< ::Tartarus::iface::SysDB::GroupManager> GroupManagerPtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::Tartarus::iface::SysDB::GroupManager> GroupManagerPrx;

void __read(::IceInternal::BasicStream*, GroupManagerPrx&);
void __patch__GroupManagerPtr(void*, ::Ice::ObjectPtr&);

}

}

}

namespace Tartarus
{

namespace iface
{

namespace SysDB
{

struct UserRecord
{
    ::Ice::Long uid;
    ::Ice::Long gid;
    ::std::string name;
    ::std::string fullName;
    ::std::string shell;

    bool operator==(const UserRecord&) const;
    bool operator<(const UserRecord&) const;
    bool operator!=(const UserRecord& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const UserRecord& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const UserRecord& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const UserRecord& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

struct GroupRecord
{
    ::Ice::Long gid;
    ::std::string name;
    ::std::string description;

    bool operator==(const GroupRecord&) const;
    bool operator<(const GroupRecord&) const;
    bool operator!=(const GroupRecord& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const GroupRecord& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const GroupRecord& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const GroupRecord& __rhs) const
    {
        return !operator<(__rhs);
    }

    void __write(::IceInternal::BasicStream*) const;
    void __read(::IceInternal::BasicStream*);
};

class UserNotFound : public ::Tartarus::iface::core::NotFoundError
{
public:

    UserNotFound() {}
    UserNotFound(const ::std::string&, const ::std::string&, ::Ice::Long);
    virtual ~UserNotFound() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::Ice::Long id;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

static UserNotFound __UserNotFound_init;

class GroupNotFound : public ::Tartarus::iface::core::NotFoundError
{
public:

    GroupNotFound() {}
    GroupNotFound(const ::std::string&, const ::std::string&, ::Ice::Long);
    virtual ~GroupNotFound() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::Ice::Long id;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class UserAlreadyExists : public ::Tartarus::iface::core::AlreadyExistsError
{
public:

    UserAlreadyExists() {}
    UserAlreadyExists(const ::std::string&, const ::std::string&, ::Ice::Long);
    virtual ~UserAlreadyExists() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::Ice::Long id;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class GroupAlreadyExists : public ::Tartarus::iface::core::AlreadyExistsError
{
public:

    GroupAlreadyExists() {}
    GroupAlreadyExists(const ::std::string&, const ::std::string&, ::Ice::Long);
    virtual ~GroupAlreadyExists() throw();

    virtual ::std::string ice_name() const;
    virtual ::Ice::Exception* ice_clone() const;
    virtual void ice_throw() const;

    static const ::IceInternal::UserExceptionFactoryPtr& ice_factory();

    ::Ice::Long id;

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

typedef ::std::vector< ::Tartarus::iface::SysDB::UserRecord> UserSeq;
void __writeUserSeq(::IceInternal::BasicStream*, const ::Tartarus::iface::SysDB::UserRecord*, const ::Tartarus::iface::SysDB::UserRecord*);
void __readUserSeq(::IceInternal::BasicStream*, UserSeq&);

typedef ::std::vector< ::Tartarus::iface::SysDB::GroupRecord> GroupSeq;
void __writeGroupSeq(::IceInternal::BasicStream*, const ::Tartarus::iface::SysDB::GroupRecord*, const ::Tartarus::iface::SysDB::GroupRecord*);
void __readGroupSeq(::IceInternal::BasicStream*, GroupSeq&);

typedef ::std::vector< ::Ice::Long> IdSeq;

}

}

}

namespace IceProxy
{

namespace Tartarus
{

namespace iface
{

namespace SysDB
{

class UserReader : virtual public ::IceProxy::Ice::Object
{
public:

    ::Tartarus::iface::SysDB::UserRecord getById(::Ice::Long uid)
    {
        return getById(uid, 0);
    }
    ::Tartarus::iface::SysDB::UserRecord getById(::Ice::Long uid, const ::Ice::Context& __ctx)
    {
        return getById(uid, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::UserRecord getById(::Ice::Long, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::SysDB::UserRecord getByName(const ::std::string& name)
    {
        return getByName(name, 0);
    }
    ::Tartarus::iface::SysDB::UserRecord getByName(const ::std::string& name, const ::Ice::Context& __ctx)
    {
        return getByName(name, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::UserRecord getByName(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::SysDB::UserSeq getUsers(const ::Tartarus::iface::SysDB::IdSeq& userIds)
    {
        return getUsers(userIds, 0);
    }
    ::Tartarus::iface::SysDB::UserSeq getUsers(const ::Tartarus::iface::SysDB::IdSeq& userIds, const ::Ice::Context& __ctx)
    {
        return getUsers(userIds, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::UserSeq getUsers(const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::SysDB::UserSeq search(const ::std::string& factor, ::Ice::Long limit)
    {
        return search(factor, limit, 0);
    }
    ::Tartarus::iface::SysDB::UserSeq search(const ::std::string& factor, ::Ice::Long limit, const ::Ice::Context& __ctx)
    {
        return search(factor, limit, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::UserSeq search(const ::std::string&, ::Ice::Long, const ::Ice::Context*);
    
public:

    ::Ice::Long count()
    {
        return count(0);
    }
    ::Ice::Long count(const ::Ice::Context& __ctx)
    {
        return count(&__ctx);
    }
    
private:

    ::Ice::Long count(const ::Ice::Context*);
    
public:

    ::Tartarus::iface::SysDB::UserSeq get(::Ice::Long limit, ::Ice::Long offset)
    {
        return get(limit, offset, 0);
    }
    ::Tartarus::iface::SysDB::UserSeq get(::Ice::Long limit, ::Ice::Long offset, const ::Ice::Context& __ctx)
    {
        return get(limit, offset, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::UserSeq get(::Ice::Long, ::Ice::Long, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<UserReader> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserReader> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserReader*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<UserReader*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class UserManager : virtual public ::IceProxy::Tartarus::iface::SysDB::UserReader
{
public:

    void modify(const ::Tartarus::iface::SysDB::UserRecord& user)
    {
        modify(user, 0);
    }
    void modify(const ::Tartarus::iface::SysDB::UserRecord& user, const ::Ice::Context& __ctx)
    {
        modify(user, &__ctx);
    }
    
private:

    void modify(const ::Tartarus::iface::SysDB::UserRecord&, const ::Ice::Context*);
    
public:

    ::Ice::Long create(const ::Tartarus::iface::SysDB::UserRecord& newUser)
    {
        return create(newUser, 0);
    }
    ::Ice::Long create(const ::Tartarus::iface::SysDB::UserRecord& newUser, const ::Ice::Context& __ctx)
    {
        return create(newUser, &__ctx);
    }
    
private:

    ::Ice::Long create(const ::Tartarus::iface::SysDB::UserRecord&, const ::Ice::Context*);
    
public:

    void _cpp_delete(::Ice::Long id)
    {
        _cpp_delete(id, 0);
    }
    void _cpp_delete(::Ice::Long id, const ::Ice::Context& __ctx)
    {
        _cpp_delete(id, &__ctx);
    }
    
private:

    void _cpp_delete(::Ice::Long, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<UserManager> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<UserManager> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<UserManager*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<UserManager*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class GroupReader : virtual public ::IceProxy::Ice::Object
{
public:

    ::Tartarus::iface::SysDB::GroupRecord getById(::Ice::Long gid)
    {
        return getById(gid, 0);
    }
    ::Tartarus::iface::SysDB::GroupRecord getById(::Ice::Long gid, const ::Ice::Context& __ctx)
    {
        return getById(gid, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::GroupRecord getById(::Ice::Long, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::SysDB::GroupRecord getByName(const ::std::string& name)
    {
        return getByName(name, 0);
    }
    ::Tartarus::iface::SysDB::GroupRecord getByName(const ::std::string& name, const ::Ice::Context& __ctx)
    {
        return getByName(name, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::GroupRecord getByName(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::SysDB::IdSeq getGroupsForUserId(::Ice::Long uid)
    {
        return getGroupsForUserId(uid, 0);
    }
    ::Tartarus::iface::SysDB::IdSeq getGroupsForUserId(::Ice::Long uid, const ::Ice::Context& __ctx)
    {
        return getGroupsForUserId(uid, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::IdSeq getGroupsForUserId(::Ice::Long, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::SysDB::IdSeq getGroupsForUserName(const ::std::string& name)
    {
        return getGroupsForUserName(name, 0);
    }
    ::Tartarus::iface::SysDB::IdSeq getGroupsForUserName(const ::std::string& name, const ::Ice::Context& __ctx)
    {
        return getGroupsForUserName(name, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::IdSeq getGroupsForUserName(const ::std::string&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::SysDB::GroupSeq getGroups(const ::Tartarus::iface::SysDB::IdSeq& groupIds)
    {
        return getGroups(groupIds, 0);
    }
    ::Tartarus::iface::SysDB::GroupSeq getGroups(const ::Tartarus::iface::SysDB::IdSeq& groupIds, const ::Ice::Context& __ctx)
    {
        return getGroups(groupIds, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::GroupSeq getGroups(const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::SysDB::IdSeq getUsers(::Ice::Long gid)
    {
        return getUsers(gid, 0);
    }
    ::Tartarus::iface::SysDB::IdSeq getUsers(::Ice::Long gid, const ::Ice::Context& __ctx)
    {
        return getUsers(gid, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::IdSeq getUsers(::Ice::Long, const ::Ice::Context*);
    
public:

    ::Tartarus::iface::SysDB::GroupSeq search(const ::std::string& factor, ::Ice::Long limit)
    {
        return search(factor, limit, 0);
    }
    ::Tartarus::iface::SysDB::GroupSeq search(const ::std::string& factor, ::Ice::Long limit, const ::Ice::Context& __ctx)
    {
        return search(factor, limit, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::GroupSeq search(const ::std::string&, ::Ice::Long, const ::Ice::Context*);
    
public:

    ::Ice::Long count()
    {
        return count(0);
    }
    ::Ice::Long count(const ::Ice::Context& __ctx)
    {
        return count(&__ctx);
    }
    
private:

    ::Ice::Long count(const ::Ice::Context*);
    
public:

    ::Tartarus::iface::SysDB::GroupSeq get(::Ice::Long limit, ::Ice::Long offset)
    {
        return get(limit, offset, 0);
    }
    ::Tartarus::iface::SysDB::GroupSeq get(::Ice::Long limit, ::Ice::Long offset, const ::Ice::Context& __ctx)
    {
        return get(limit, offset, &__ctx);
    }
    
private:

    ::Tartarus::iface::SysDB::GroupSeq get(::Ice::Long, ::Ice::Long, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<GroupReader> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupReader> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupReader*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<GroupReader*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

class GroupManager : virtual public ::IceProxy::Tartarus::iface::SysDB::GroupReader
{
public:

    void setUsers(::Ice::Long gid, const ::Tartarus::iface::SysDB::IdSeq& userIds)
    {
        setUsers(gid, userIds, 0);
    }
    void setUsers(::Ice::Long gid, const ::Tartarus::iface::SysDB::IdSeq& userIds, const ::Ice::Context& __ctx)
    {
        setUsers(gid, userIds, &__ctx);
    }
    
private:

    void setUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);
    
public:

    void addUsers(::Ice::Long gid, const ::Tartarus::iface::SysDB::IdSeq& userIds)
    {
        addUsers(gid, userIds, 0);
    }
    void addUsers(::Ice::Long gid, const ::Tartarus::iface::SysDB::IdSeq& userIds, const ::Ice::Context& __ctx)
    {
        addUsers(gid, userIds, &__ctx);
    }
    
private:

    void addUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);
    
public:

    void delUsers(::Ice::Long gid, const ::Tartarus::iface::SysDB::IdSeq& userIds)
    {
        delUsers(gid, userIds, 0);
    }
    void delUsers(::Ice::Long gid, const ::Tartarus::iface::SysDB::IdSeq& userIds, const ::Ice::Context& __ctx)
    {
        delUsers(gid, userIds, &__ctx);
    }
    
private:

    void delUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);
    
public:

    void modify(const ::Tartarus::iface::SysDB::GroupRecord& group)
    {
        modify(group, 0);
    }
    void modify(const ::Tartarus::iface::SysDB::GroupRecord& group, const ::Ice::Context& __ctx)
    {
        modify(group, &__ctx);
    }
    
private:

    void modify(const ::Tartarus::iface::SysDB::GroupRecord&, const ::Ice::Context*);
    
public:

    ::Ice::Long create(const ::Tartarus::iface::SysDB::GroupRecord& newGroup)
    {
        return create(newGroup, 0);
    }
    ::Ice::Long create(const ::Tartarus::iface::SysDB::GroupRecord& newGroup, const ::Ice::Context& __ctx)
    {
        return create(newGroup, &__ctx);
    }
    
private:

    ::Ice::Long create(const ::Tartarus::iface::SysDB::GroupRecord&, const ::Ice::Context*);
    
public:

    void _cpp_delete(::Ice::Long id)
    {
        _cpp_delete(id, 0);
    }
    void _cpp_delete(::Ice::Long id, const ::Ice::Context& __ctx)
    {
        _cpp_delete(id, &__ctx);
    }
    
private:

    void _cpp_delete(::Ice::Long, const ::Ice::Context*);
    
public:

    void addUserToGroups(::Ice::Long uid, const ::Tartarus::iface::SysDB::IdSeq& groups)
    {
        addUserToGroups(uid, groups, 0);
    }
    void addUserToGroups(::Ice::Long uid, const ::Tartarus::iface::SysDB::IdSeq& groups, const ::Ice::Context& __ctx)
    {
        addUserToGroups(uid, groups, &__ctx);
    }
    
private:

    void addUserToGroups(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);
    
public:

    void delUserFromGroups(::Ice::Long uid, const ::Tartarus::iface::SysDB::IdSeq& groups)
    {
        delUserFromGroups(uid, groups, 0);
    }
    void delUserFromGroups(::Ice::Long uid, const ::Tartarus::iface::SysDB::IdSeq& groups, const ::Ice::Context& __ctx)
    {
        delUserFromGroups(uid, groups, &__ctx);
    }
    
private:

    void delUserFromGroups(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<GroupManager> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<GroupManager> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<GroupManager*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<GroupManager*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

}

}

}

}

namespace IceDelegate
{

namespace Tartarus
{

namespace iface
{

namespace SysDB
{

class UserReader : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::Tartarus::iface::SysDB::UserRecord getById(::Ice::Long, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::SysDB::UserRecord getByName(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::SysDB::UserSeq getUsers(const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::SysDB::UserSeq search(const ::std::string&, ::Ice::Long, const ::Ice::Context*) = 0;

    virtual ::Ice::Long count(const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::SysDB::UserSeq get(::Ice::Long, ::Ice::Long, const ::Ice::Context*) = 0;
};

class UserManager : virtual public ::IceDelegate::Tartarus::iface::SysDB::UserReader
{
public:

    virtual void modify(const ::Tartarus::iface::SysDB::UserRecord&, const ::Ice::Context*) = 0;

    virtual ::Ice::Long create(const ::Tartarus::iface::SysDB::UserRecord&, const ::Ice::Context*) = 0;

    virtual void _cpp_delete(::Ice::Long, const ::Ice::Context*) = 0;
};

class GroupReader : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual ::Tartarus::iface::SysDB::GroupRecord getById(::Ice::Long, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::SysDB::GroupRecord getByName(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::SysDB::IdSeq getGroupsForUserId(::Ice::Long, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::SysDB::IdSeq getGroupsForUserName(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::SysDB::GroupSeq getGroups(const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::SysDB::IdSeq getUsers(::Ice::Long, const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::SysDB::GroupSeq search(const ::std::string&, ::Ice::Long, const ::Ice::Context*) = 0;

    virtual ::Ice::Long count(const ::Ice::Context*) = 0;

    virtual ::Tartarus::iface::SysDB::GroupSeq get(::Ice::Long, ::Ice::Long, const ::Ice::Context*) = 0;
};

class GroupManager : virtual public ::IceDelegate::Tartarus::iface::SysDB::GroupReader
{
public:

    virtual void setUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*) = 0;

    virtual void addUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*) = 0;

    virtual void delUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*) = 0;

    virtual void modify(const ::Tartarus::iface::SysDB::GroupRecord&, const ::Ice::Context*) = 0;

    virtual ::Ice::Long create(const ::Tartarus::iface::SysDB::GroupRecord&, const ::Ice::Context*) = 0;

    virtual void _cpp_delete(::Ice::Long, const ::Ice::Context*) = 0;

    virtual void addUserToGroups(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*) = 0;

    virtual void delUserFromGroups(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*) = 0;
};

}

}

}

}

namespace IceDelegateM
{

namespace Tartarus
{

namespace iface
{

namespace SysDB
{

class UserReader : virtual public ::IceDelegate::Tartarus::iface::SysDB::UserReader,
                   virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::Tartarus::iface::SysDB::UserRecord getById(::Ice::Long, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::UserRecord getByName(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::UserSeq getUsers(const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::UserSeq search(const ::std::string&, ::Ice::Long, const ::Ice::Context*);

    virtual ::Ice::Long count(const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::UserSeq get(::Ice::Long, ::Ice::Long, const ::Ice::Context*);
};

class UserManager : virtual public ::IceDelegate::Tartarus::iface::SysDB::UserManager,
                    virtual public ::IceDelegateM::Tartarus::iface::SysDB::UserReader
{
public:

    virtual void modify(const ::Tartarus::iface::SysDB::UserRecord&, const ::Ice::Context*);

    virtual ::Ice::Long create(const ::Tartarus::iface::SysDB::UserRecord&, const ::Ice::Context*);

    virtual void _cpp_delete(::Ice::Long, const ::Ice::Context*);
};

class GroupReader : virtual public ::IceDelegate::Tartarus::iface::SysDB::GroupReader,
                    virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual ::Tartarus::iface::SysDB::GroupRecord getById(::Ice::Long, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::GroupRecord getByName(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::IdSeq getGroupsForUserId(::Ice::Long, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::IdSeq getGroupsForUserName(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::GroupSeq getGroups(const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::IdSeq getUsers(::Ice::Long, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::GroupSeq search(const ::std::string&, ::Ice::Long, const ::Ice::Context*);

    virtual ::Ice::Long count(const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::GroupSeq get(::Ice::Long, ::Ice::Long, const ::Ice::Context*);
};

class GroupManager : virtual public ::IceDelegate::Tartarus::iface::SysDB::GroupManager,
                     virtual public ::IceDelegateM::Tartarus::iface::SysDB::GroupReader
{
public:

    virtual void setUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);

    virtual void addUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);

    virtual void delUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);

    virtual void modify(const ::Tartarus::iface::SysDB::GroupRecord&, const ::Ice::Context*);

    virtual ::Ice::Long create(const ::Tartarus::iface::SysDB::GroupRecord&, const ::Ice::Context*);

    virtual void _cpp_delete(::Ice::Long, const ::Ice::Context*);

    virtual void addUserToGroups(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);

    virtual void delUserFromGroups(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);
};

}

}

}

}

namespace IceDelegateD
{

namespace Tartarus
{

namespace iface
{

namespace SysDB
{

class UserReader : virtual public ::IceDelegate::Tartarus::iface::SysDB::UserReader,
                   virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::Tartarus::iface::SysDB::UserRecord getById(::Ice::Long, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::UserRecord getByName(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::UserSeq getUsers(const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::UserSeq search(const ::std::string&, ::Ice::Long, const ::Ice::Context*);

    virtual ::Ice::Long count(const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::UserSeq get(::Ice::Long, ::Ice::Long, const ::Ice::Context*);
};

class UserManager : virtual public ::IceDelegate::Tartarus::iface::SysDB::UserManager,
                    virtual public ::IceDelegateD::Tartarus::iface::SysDB::UserReader
{
public:

    virtual void modify(const ::Tartarus::iface::SysDB::UserRecord&, const ::Ice::Context*);

    virtual ::Ice::Long create(const ::Tartarus::iface::SysDB::UserRecord&, const ::Ice::Context*);

    virtual void _cpp_delete(::Ice::Long, const ::Ice::Context*);
};

class GroupReader : virtual public ::IceDelegate::Tartarus::iface::SysDB::GroupReader,
                    virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual ::Tartarus::iface::SysDB::GroupRecord getById(::Ice::Long, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::GroupRecord getByName(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::IdSeq getGroupsForUserId(::Ice::Long, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::IdSeq getGroupsForUserName(const ::std::string&, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::GroupSeq getGroups(const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::IdSeq getUsers(::Ice::Long, const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::GroupSeq search(const ::std::string&, ::Ice::Long, const ::Ice::Context*);

    virtual ::Ice::Long count(const ::Ice::Context*);

    virtual ::Tartarus::iface::SysDB::GroupSeq get(::Ice::Long, ::Ice::Long, const ::Ice::Context*);
};

class GroupManager : virtual public ::IceDelegate::Tartarus::iface::SysDB::GroupManager,
                     virtual public ::IceDelegateD::Tartarus::iface::SysDB::GroupReader
{
public:

    virtual void setUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);

    virtual void addUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);

    virtual void delUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);

    virtual void modify(const ::Tartarus::iface::SysDB::GroupRecord&, const ::Ice::Context*);

    virtual ::Ice::Long create(const ::Tartarus::iface::SysDB::GroupRecord&, const ::Ice::Context*);

    virtual void _cpp_delete(::Ice::Long, const ::Ice::Context*);

    virtual void addUserToGroups(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);

    virtual void delUserFromGroups(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Context*);
};

}

}

}

}

namespace Tartarus
{

namespace iface
{

namespace SysDB
{

class UserReader : virtual public ::Ice::Object
{
public:

    typedef UserReaderPrx ProxyType;
    typedef UserReaderPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Tartarus::iface::SysDB::UserRecord getById(::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getById(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::SysDB::UserRecord getByName(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getByName(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::SysDB::UserSeq getUsers(const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getUsers(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::SysDB::UserSeq search(const ::std::string&, ::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___search(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Long count(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___count(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::SysDB::UserSeq get(::Ice::Long, ::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___get(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class UserManager : virtual public ::Tartarus::iface::SysDB::UserReader
{
public:

    typedef UserManagerPrx ProxyType;
    typedef UserManagerPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void modify(const ::Tartarus::iface::SysDB::UserRecord&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___modify(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Long create(const ::Tartarus::iface::SysDB::UserRecord&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___create(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void _cpp_delete(::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___delete(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class GroupReader : virtual public ::Ice::Object
{
public:

    typedef GroupReaderPrx ProxyType;
    typedef GroupReaderPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual ::Tartarus::iface::SysDB::GroupRecord getById(::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getById(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::SysDB::GroupRecord getByName(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getByName(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::SysDB::IdSeq getGroupsForUserId(::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getGroupsForUserId(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::SysDB::IdSeq getGroupsForUserName(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getGroupsForUserName(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::SysDB::GroupSeq getGroups(const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getGroups(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::SysDB::IdSeq getUsers(::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getUsers(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::SysDB::GroupSeq search(const ::std::string&, ::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___search(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Long count(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___count(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Tartarus::iface::SysDB::GroupSeq get(::Ice::Long, ::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___get(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

class GroupManager : virtual public ::Tartarus::iface::SysDB::GroupReader
{
public:

    typedef GroupManagerPrx ProxyType;
    typedef GroupManagerPtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void setUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setUsers(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void addUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___addUsers(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void delUsers(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___delUsers(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void modify(const ::Tartarus::iface::SysDB::GroupRecord&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___modify(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::Long create(const ::Tartarus::iface::SysDB::GroupRecord&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___create(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void _cpp_delete(::Ice::Long, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___delete(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void addUserToGroups(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___addUserToGroups(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void delUserFromGroups(::Ice::Long, const ::Tartarus::iface::SysDB::IdSeq&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___delUserFromGroups(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

}

}

}

#endif
